RandomYield = {
  yield = math.random() * 1.7 + 0.5,
  fruitTypesYield = {}
}

function RandomYield:randomizeYields()
  for _, fruitType in ipairs(g_currentMission.fruitTypeManager.fruitTypes) do
    self.fruitTypesYield[fruitType.index] = fruitType.literPerSqm
    fruitType.literPerSqm = self.fruitTypesYield[fruitType.index] * self.yield
  end
end

function RandomYield:loadMap(name)
  self:randomizeYields()
  g_messageCenter:subscribe(MessageType.PERIOD_CHANGED, self.onPeriodChanged, self)
end

function RandomYield:onPeriodChanged(data)
  self.yield = math.random() * 1.7 + 0.5
  if self.yield > 1.5 then
    self.yield = g_currentMission.fruitTypeManager.defaultLiterPerSqm
  end
  self:randomizeYields()
end

addModEventListener(RandomYield)